#include <arduino.h>
#include <avr/io.h>
#include "sseg.h"


byte gSegmentDatas[39] =
{
//     abcdefg
	 0b0000001, // 0
	 0b1001111, // 1
	 0b0010010, // 2
	 0b0000110, // 3
	 0b1001100, // 4
	 0b0100100, // 5
	 0b0100000, // 6
	 0b0001101, // 7
	 0b0000000, // 8
	 0b0000100, // 9
	 0b1111111, // NONE
	 0b1111110, // MINUS
	 0b0001000, // A
	 0b1100000, // b
	 0b0110001, // C
	 0b1000010, // d
	 0b0110000, // E
	 0b0111000, // F
	 0b0110001, // G
	 0b1001000, // H
	 0b1001111, // I
	 0b1000111, // J
	 0b1111000, // k
	 0b1110001, // L
	 0b0001001, // m
	 0b1101010, // n
	 0b1100010, // o
	 0b0011000, // P
	 0b0001100, // q
	 0b1111010, // r
	 0b0100110, // s
	 0b0110101, // T
	 0b1000001, // U
	 0b1100011, // v
	 0b1011011, // w
	 0b1001000, // X
	 0b1001100, // y
	 0b0110110, // z
	 0b1111110  // Special(Div)
};


SSEG::SSEG(byte inD1, byte inD2, byte inA, byte inB, byte inC, byte inD, byte inE, byte inF, byte inG)
{
	led_d1 = inD1;
	led_d2 = inD2;
	led_a = inA;
	led_b = inB;
	led_c = inC;
	led_d = inD;
	led_e = inE;
	led_f = inF;
	led_g = inG;
	
	number_displayed = 0;
	current_digit = 0;
	
	word1_displayed = SSEG_NONE;
	word2_displayed = SSEG_NONE;
	
	SetInit();
}

void SSEG::SetInit()
{
	pinMode(led_d1, OUTPUT);
	pinMode(led_d2, OUTPUT);
	pinMode(led_a, OUTPUT);
	pinMode(led_b, OUTPUT);
	pinMode(led_c, OUTPUT);
	pinMode(led_d, OUTPUT);
	pinMode(led_e, OUTPUT);
	pinMode(led_f, OUTPUT);
	pinMode(led_g, OUTPUT);
	
	
}

void SSEG::DisplayClear()
{
	Display(SSEG_NONE);
}

void SSEG::Display(int inWord)
{
	
	if( inWord < 38)
	{
		//A3, A4, 2, 3, 4, A5, A2
		/*
		if( ((gSegmentDatas[inWord] >> 6) & 1) > 0)
		{
			PORTC = PORTC | _BV(3);
		}
		else
		{
			PORTC = PORTC & ~_BV(3);
		}
		*/
		
		digitalWrite(led_a, (gSegmentDatas[inWord] >> 6) & 1);
		digitalWrite(led_b, (gSegmentDatas[inWord] >> 5) & 1);
		digitalWrite(led_c, (gSegmentDatas[inWord] >> 4) & 1);
		digitalWrite(led_d, (gSegmentDatas[inWord] >> 3) & 1);
		digitalWrite(led_e, (gSegmentDatas[inWord] >> 2) & 1);
		digitalWrite(led_f, (gSegmentDatas[inWord] >> 1) & 1);
		digitalWrite(led_g, (gSegmentDatas[inWord] >> 0) & 1);
	}
}

void SSEG::ChangeDigit(int inDigit)
{
	//7, 8,
	switch(inDigit)
	{
	case 0:
		digitalWrite(led_d1, 0);
		digitalWrite(led_d2, 1);
		break;
	case 1:
		digitalWrite(led_d1, 1);
		digitalWrite(led_d2, 0);
		break;
	default:
		digitalWrite(led_d1, 1);
		digitalWrite(led_d2, 1);
		break;
	}
}

void SSEG::ShowNumber()
{
	byte aNumber = 0;
	
	if( current_digit == 0)
	{
		current_digit = 1;
		
		aNumber = number_displayed / 10;
	}
	else
	{
		current_digit = 0;
		
		aNumber = number_displayed % 10;
		
	}
	
	//Change digit
	ChangeDigit(current_digit);
	
	// Show number
	Display(aNumber);
	
}

void SSEG::SetNumber(byte inNumber)
{
	
	number_displayed = inNumber;
	
	
}

void SSEG::ShowWord()
{
	byte aNumber = 0;
	
	if( current_digit == 0)
	{
		current_digit = 1;
		
		aNumber = word1_displayed;
	}
	else
	{
		current_digit = 0;
		
		aNumber = word2_displayed;
		
	}
	
	//Change digit
	ChangeDigit(current_digit);
	
	// Show number
	Display(aNumber);
	
}

void SSEG::SetWord(byte inWord1, byte inWord2)
{
	
	word1_displayed = inWord1;
	word2_displayed = inWord2;
	
	
}

void SSEG::SetCVNumber(byte inNumber)
{
	
	word1_displayed = SSEG_C;
	word2_displayed = inNumber;
	
	
}

void SSEG::SetCVValue(byte inNumber)
{
	
	word1_displayed = inNumber / 10;
	word2_displayed = inNumber % 10;
	
	
}

void SSEG::SetAccessory(byte inNumber)
{
	
	word1_displayed = SSEG_A;
	word2_displayed = inNumber;
	
	
}
